# Class DeflaterOutputStream

java.lang.Object
java.io.OutputStream
com.codename1.io.gzip.FilterOutputStream
com.codename1.io.gzip.DeflaterOutputStream

All Implemented Interfaces:
  `AutoCloseable`

Direct Known Subclasses:
  `GZIPOutputStream`

public class DeflaterOutputStream extends FilterOutputStream

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected byte[]`
  `buffer`
  `protected static final int`
  `DEFAULT_BUFSIZE`
  `protected final Deflater`
  `deflater`
  `protected boolean`
  `mydeflater`

  ### Fields inherited from class FilterOutputStream

  `out`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DeflaterOutputStream(OutputStream out)`
  `DeflaterOutputStream(OutputStream out, Deflater def)`
  `DeflaterOutputStream(OutputStream out, Deflater deflater, int size)`
  `DeflaterOutputStream(OutputStream out, Deflater deflater, int size, boolean closeOut)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  Closes this output stream and releases any system resources associated with this stream.
  `protected int`
  `deflate(int flush)`
  `void`
  `finish()`
  `void`
  `flush()`
  Flushes this output stream and forces any buffered output bytes to be written out.
  `Deflater`
  `getDeflater()`
  `boolean`
  `getSyncFlush()`
  `long`
  `getTotalIn()`
  `long`
  `getTotalOut()`
  `void`
  `setSyncFlush(boolean syncFlush)`
  `void`
  `write(byte[] b, int off, int len)`
  Writes len bytes from the specified byte array starting at offset off to this output stream.
  `void`
  `write(int b)`
  Writes the specified byte to this output stream.

  ### Methods inherited from class FilterOutputStream

  `write`

  ### Methods inherited from class Object

  `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### DEFAULT_BUFSIZE

    protected static final int DEFAULT_BUFSIZE
    See Also:
      - Constant Field Values

  - ### deflater

    protected final Deflater deflater

  - ### buffer

    protected byte[] buffer

  - ### mydeflater

    protected boolean mydeflater

- ## Constructor Details

  - ### DeflaterOutputStream

    public DeflaterOutputStream(OutputStream out) throws IOException
    Throws:
      `IOException`

  - ### DeflaterOutputStream

    public DeflaterOutputStream(OutputStream out, Deflater def) throws IOException
    Throws:
      `IOException`

  - ### DeflaterOutputStream

    public DeflaterOutputStream(OutputStream out, Deflater deflater, int size) throws IOException
    Throws:
      `IOException`

  - ### DeflaterOutputStream

    public DeflaterOutputStream(OutputStream out, Deflater deflater, int size, boolean closeOut) throws IOException
    Throws:
      `IOException`

- ## Method Details

  - ### write

    public void write(int b) throws IOException
    Description copied from class: `OutputStream`
    Writes the specified byte to this output stream. The general contract for write is that one byte is written to the output stream. The byte to be written is the eight low-order bits of the argument b. The 24 high-order bits of b are ignored. Subclasses of OutputStream must provide an implementation for this method.
    Overrides:
      `write` in class `FilterOutputStream`
    Throws:
      `IOException`

  - ### write

    public void write(byte[] b, int off, int len) throws IOException
    Description copied from class: `OutputStream`

    Writes len bytes from the specified byte array starting at offset off to this output stream. The general contract for write(b, off, len) is that some of the bytes in the array b are written to the output stream in order; element b

    invalid reference

        off

    is the first byte written and b[off+len-1] is the last byte written by this operation.

    The write method of OutputStream calls the write method of one argument on each of the bytes to be written out. Subclasses are encouraged to override this method and provide a more efficient implementation. If b is null, a NullPointerException is thrown. If off is negative, or len is negative, or off+len is greater than the length of the array b, then an IndexOutOfBoundsException is thrown.

    Overrides:
      `write` in class `FilterOutputStream`
    Throws:
      `IOException`

  - ### finish

    public void finish() throws IOException
    Throws:
      `IOException`

  - ### close

    public void close() throws IOException
    Description copied from class: `OutputStream`
    Closes this output stream and releases any system resources associated with this stream. The general contract of close is that it closes the output stream. A closed stream cannot perform output operations and cannot be reopened. The close method of OutputStream does nothing.
    Specified by:
      `close` in interface `AutoCloseable`
    Overrides:
      `close` in class `FilterOutputStream`
    Throws:
      `IOException`

  - ### deflate

    protected int deflate(int flush) throws IOException
    Throws:
      `IOException`

  - ### flush

    public void flush() throws IOException
    Description copied from class: `OutputStream`
    Flushes this output stream and forces any buffered output bytes to be written out. The general contract of flush is that calling it is an indication that, if any bytes previously written have been buffered by the implementation of the output stream, such bytes should immediately be written to their intended destination. The flush method of OutputStream does nothing.
    Overrides:
      `flush` in class `FilterOutputStream`
    Throws:
      `IOException`

  - ### getTotalIn

    public long getTotalIn()

  - ### getTotalOut

    public long getTotalOut()

  - ### getSyncFlush

    public boolean getSyncFlush()

  - ### setSyncFlush

    public void setSyncFlush(boolean syncFlush)

  - ### getDeflater

    public Deflater getDeflater()